# Detect the distribution in use
%global __despace head -n 1 | tr -d '[:space:]' | sed -e 's/[(].*[)]//g'
%global __lower4 cut -c 1-4 | tr '[:upper:]' '[:lower:]'
%global __distfile %([ -f /etc/SuSE-release ] && echo /etc/SuSE-release || echo /etc/redhat-release)
%global __distinit %(sed -e 's/ release .*//' -e 's/\\([A-Za-z]\\)[^ ]*/\\1/g' %{__distfile} | %{__despace} | %{__lower4})
%global __distvers %(sed -e 's/.* release \\([^. ]*\\).*/\\1/' %{__distfile} | %{__despace})
# Identify CentOS Linux and Scientific Linux as rhel
%if "%{__distinit}" == "c" || "%{__distinit}" == "cl" || "%{__distinit}" == "sl" || "%{__distinit}" == "sls"
%global __distinit rhel
%endif
# Dist tag for Fedora is still "fc"
%if "%{__distinit}" == "f"
%global __distinit fc
%endif

Name:		perl-Test-NoWarnings
Version:	1.04
Release:	10.%{__distinit}%{__distvers}
Summary:	Make sure you didn't emit any warnings while testing
License:	LGPLv2+
Group:		Development/Libraries
URL:		http://search.cpan.org/dist/Test-NoWarnings/
Source0:	http://search.cpan.org/CPAN/authors/id/A/AD/ADAMK/Test-NoWarnings-%{version}.tar.gz
BuildRoot:	%{_tmppath}/%{name}-%{version}-%{release}-root-%(id -nu)
BuildArch:	noarch
# Module Build
BuildRequires:	coreutils
BuildRequires:	findutils
BuildRequires:	make
BuildRequires:	perl
%if 0%{?fedora} > 20 || 0%{?rhel} > 7
BuildRequires:	perl-generators
%endif
BuildRequires:	perl(ExtUtils::MakeMaker)
# Module Runtime
BuildRequires:	perl(Carp)
BuildRequires:	perl(Exporter)
BuildRequires:	perl(strict)
# Wants Test::Builder ≥ 0.86 but 0.32 on FC-5 works just fine
BuildRequires:	perl(Test::Builder)
BuildRequires:	perl(vars)
BuildRequires:	perl(warnings)
# Optional Runtime
BuildRequires:	perl(Devel::StackTrace)
# Test Suite
BuildRequires:	perl(Test::More)
BuildRequires:	perl(Test::Tester) >= 0.103
# Extra Tests
BuildRequires:	perl(Pod::Simple) >= 3.14
BuildRequires:	perl(Test::CPAN::Meta) >= 0.17
# Test::MinimumVersion → Perl::MinimumVersion → PPI → Test::NoWarnings
%if 0%{!?perl_bootstrap:1}
BuildRequires:	perl(Perl::MinimumVersion) >= 1.27
BuildRequires:	perl(Test::MinimumVersion) >= 0.101080
%endif
BuildRequires:	perl(Test::Pod) >= 1.44
# Dependencies
Requires:	perl(:MODULE_COMPAT_%(eval "`perl -V:version`"; echo $version))
Requires:	perl(Devel::StackTrace)

%description
In general, your tests shouldn't produce warnings. This module causes any
warnings to be captured and stored. It automatically adds an extra test
that will run when your script ends to check that there were no warnings.
If there were any warnings, the test will give a "not ok" and diagnostics of
where, when and what the warning was, including a stack trace of what was
going on when it occurred.

%prep
%setup -q -n Test-NoWarnings-%{version}

%build
perl Makefile.PL INSTALLDIRS=vendor
make %{?_smp_mflags}

%install
rm -rf %{buildroot}
make pure_install DESTDIR=%{buildroot}
find %{buildroot} -type f -name .packlist -delete
%{_fixperms} %{buildroot}

%check
make test
make test AUTOMATED_TESTING=1 TEST_FILES="xt/*.t"

%clean
rm -rf %{buildroot}

%files
%if 0%{?_licensedir:1}
%license LICENSE
%else
%doc LICENSE
%endif
%doc Changes README
%{perl_vendorlib}/Test/
%{_mandir}/man3/Test::NoWarnings.3*

%changelog
* Tue Oct  4 2016 Paul Howarth <paul@city-fan.org> - 1.04-10
- Classify buildreqs by usage
- Simplify find command using -delete

* Mon Sep  1 2014 Paul Howarth <paul@city-fan.org> - 1.04-6
- Drop %%defattr, redundant since rpm 4.4
- Use %%license where possible

* Mon Jul 16 2012 Paul Howarth <paul@city-fan.org> - 1.04-4
- Perl 5.16 post-bootstrap rebuild

* Wed Jul  4 2012 Paul Howarth <paul@city-fan.org> - 1.04-3
- BR: perl(Exporter) and perl(Test::Builder)
- Don't need to remove empty directories from the buildroot
- Drop support for old distributions prior to FC-3:
  - Don't need to define %%{perl_vendorlib}
  - Use DESTDIR rather than PERL_INSTALL_ROOT
  - Use %%{_fixperms} macro rather than our own chmod incantation

* Tue Feb  7 2012 Paul Howarth <paul@city-fan.org> - 1.04-2
- Don't BR: perl(Test::MinimumVersion) if we're bootstrapping

* Thu Dec  1 2011 Paul Howarth <paul@city-fan.org> - 1.04-1
- Update to 1.04
  - Added the experimental :early debugging pragma to cause warnings to be
    emitted immediately (this should stay off otherwise)
- BR: perl(Carp)

* Tue Aug  2 2011 Paul Howarth <paul@city-fan.org> - 1.03-1
- Update to 1.03
  - Test::Builder and Test::Tester dependencies were the wrong way around
    (build vs. runtime)
- Reinstate buildreqs from previous build and run release tests

* Tue Jun 28 2011 Paul Howarth <paul@city-fan.org> - 1.02-3
- Rebuild for perl 5.14.1 in Rawhide
- Drop redundant buildreqs:
  - perl(Perl::MinimumVersion)
  - perl(Pod::Simple)
  - perl(Test::CPAN::Meta)
  - perl(Test::Pod)
- Add buildreq perl(Test::More)
- Add runtime dependency on perl(Devel::StackTrace) for enhanced functionality
- Nobody else likes macros for commands
- Fix dist tag for CentOS 6 and Scientific Linux

* Thu Sep  9 2010 Paul Howarth <paul@city-fan.org> - 1.02-1
- Update to 1.02
  - Don't "use warnings" anywhere inside of Test::NoWarnings::*
  - Remove the need for a private variable when detecting Devel::StackTrace
  - Don't import unused functions from Carp or Test::Builder
  - Minor documentation tweaks
  - Correct the repository metadata in META.yml
  - Minor cleanups in the eumm-update generated code
  - Added a dedicated compile test

* Wed Jun 23 2010 Paul Howarth <paul@city-fan.org> - 1.01-3
- Rebuild for perl 5.12.1 in Rawhide

* Wed May 12 2010 Paul Howarth <paul@city-fan.org> - 1.01-2
- Fix dist tag for RHEL-6 Beta

* Sat Jan 16 2010 Paul Howarth <paul@city-fan.org> - 1.01-1
- Update to 1.01 (clarify license as LGPLv2+ - CPAN RT#53614)
- LICENSE restored to upstream distribution

* Tue Jan 12 2010 Paul Howarth <paul@city-fan.org> - 1.00-1
- Update to 1.00 (general cleanup, no functional changes)
- New upstream maintainer -> new source URL
- Buildreq perl(Devel::StackTrace) for extra test coverage
- Enable AUTOMATED_TESTING
- Buildreq perl(Test::CPAN::Meta), perl(Pod::Simple), perl(Test::Pod),
  perl(Perl::MinimumVersion), perl(Test::MinimumVersion)
- Dist tag for Rawhide no longer needs special-casing
- License text not included in upstream distribution anymore (CPAN RT#53614)

* Wed Sep 30 2009 Paul Howarth <paul@city-fan.org> - 0.084-3
- Define RPM macros in global scope

* Fri Nov 14 2008 Paul Howarth <paul@city-fan.org> - 0.084-2
- Tweak dist tag macros to work on current Rawhide with three-part releasenum

* Fri Nov 30 2007 Paul Howarth <paul@city-fan.org> - 0.084-1
- Import from Fedora
- Update to 0.084
- Clarify license as LGPL (any version)
- Cosmetic changes and dist tag generation

* Wed Apr 18 2007 Steven Pritchard <steve@kspei.com> - 0.083-2
- BR ExtUtils::MakeMaker

* Tue Dec 26 2006 Steven Pritchard <steve@kspei.com> - 0.083-1
- Update to 0.083
- Use fixperms macro instead of our own chmod incantation

* Sat Sep 16 2006 Steven Pritchard <steve@kspei.com> - 0.082-2
- Fix find option order

* Sat Apr 08 2006 Steven Pritchard <steve@kspei.com> - 0.082-1
- Specfile autogenerated by cpanspec 1.64
- Fix License
- Drop explicit dependency on perl(Test::Tester) (seems to be bogus)
